'****************************************************************************
' Developed & Written by Greg Cook --- ? ?, 2001
' Version: v2001.??.??
' Email: greg_cook@bigoot.com
' Web site: http://www.bigfoot.com/~greg_cook
'
' PURPOSE:
'
' 
'
' USAGE:
'
' Double-click it to run, and you will be prompted for the path to the
' files. Or you can run it in a "short-cut," supplying the path as an
' "argument."
'
' <myname>.vbs arg1
'
' arg1 = 
'
' Double-click it to run, and you will be prompted for the path and for what to
' do to the files. Or you can run it in a "short-cut," supplying the path and
' what to do as "arguments."
'
' <myname>.vbs arg1 arg2
'
' arg1 = 
' arg2 = 
'
' DISCLAIMER:
'
' This script is FREE for your use, so please use and share with others
' as you see fit.
'
' This software is provided AS IS without warranty of any kind including but
' not limited to the implied warranties of merchantability and fitness for a
' particular purpose. The publisher assumes no liability for any alleged or
' actual damages arising from the use of this program. (Some states do not
' allow the exclusion of implied warranties, so the exclusion may not apply
' to you.)
'
' If you are interested in learning about VBScript (or JavaScript) check out:
' http://msdn.microsoft.com/scripting/
'****************************************************************************

'****************************************************************************
'Clear memory before exiting
'****************************************************************************
Sub Cleanup()
  'Close files that were opened
  objStatusFile.Close
  Err.Clear
  'Clear object variables
  Set objStatusFile = Nothing
  Set objArgs = Nothing
  Set shell = Nothing
  Set fso = Nothing
End Sub

'****************************************************************************
'Write the specified string to the log file
'****************************************************************************
Sub WriteLog(strStatus)
  'Bypass all errors
  On Error Resume Next
  objLogFile.Write strStatus & vbNewLine
End Sub

'****************************************************************************
' Make the specified file or folder's attribute read-only or remove it's
' read-only attribute
'****************************************************************************
Sub MakeReadOnly(objFileOrFolder, blnMakeReadOnly)
  'Bypass all errors
  On Error Resume Next
  With objFileOrFolder
    If .Attributes And 1 Then
      If Not blnMakeReadOnly Then
        .Attributes = .Attributes - 1
        WriteLog .Path
        lngFileCount = lngFileCount + 1
      End If
    Else
      If blnMakeReadOnly Then
        .Attributes = .Attributes + 1
        WriteLog .Path
        lngFileCount = lngFileCount + 1
      End If
    End If
  End With
  Err.Clear
End Sub

'************************************************
' Return the current user's username
'************************************************
Function CurrentUser()
  On Error Resume Next

  Dim strUsername
  Dim intCnt

 'Wait until the username gets filled in
  Do
   strUsername = net.UserName
   intCnt = intCnt + 1
  Loop While Len(strUsername) = 0 And intCnt < 32765
  Err.Clear

  'If the username is not empty    
  If Len(strUsername) <> 0 Then CurrentUser = LCase(strUsername)
  Err.Clear
End Function

'************************************************
' Show current scripting engine version
'************************************************
Sub ShowScriptVersion()
  With WScript
    .Echo "Windows Scripting (" & .Fullname & ") is v" & .Version
  End With
End Sub

'****************************************************************************
'Return a string with the last backslash removed
'****************************************************************************
Function RemoveBackslash(strString)
  On Error Resume Next
  If Right(strString, 1) = "\" Then
    RemoveBackslash = Left(strString, Len(strString) - 1)
  Else
    RemoveBackslash = strString
  End If
End Function

'****************************************************************************
'Return a string with the last backslash added
'****************************************************************************
Function AddBackslash(strString)
  On Error Resume Next
  If Right(strString, 1) <> "\" Then
    AddBackslash = strString & "\"
  Else
    AddBackslash = strString
  End If
End Function

'************************************************
' Map the specified drive to the specified share
' and return True if it mapped, Fals if it is not.
'************************************************
Function MapDrive(strDrive, strShare)
  On Error Resume Next

  Dim colDrives
  Dim intCnt
  Dim intItem

  'If the directory does not exist
  If Not (fso.FolderExists(strShare)) Then
    MsgBox "Unable to map to " & strShare & " because the directory does not exist! Please notify Help Desk.", vbCritical, "Map Drive Error"
    Exit Function
  End If

  'Get a list of the network drives
  Set colDrives = net.EnumNetworkDrives

  intCnt = colDrives.Count - 1

  'If any drives networked
  If intCnt > 0 Then
    'If the drive matches the drive we want to map, and
    'the share of that drive matches the share we want to map
    'it return's True (already connected). Otherwise,
    'force a disconnect of the currently mapped drive
    '(because it is the incorrect one)
    For intItem = 0 To intCnt Step 2
      If colDrives(intItem) = strDrive Then
        If LCase(colDrives(intItem + 1)) = strShare Then
          MapDrive = True
          Exit Function
        Else
          net.RemoveNetworkDrive strDrive, True, True
        End If
        Exit For
      End If
    Next
  End If
  'Clear any errors that occurred
  Err.Clear

  'Map the drive to the share
  net.MapNetworkDrive strDrive, strShare
  'Return success
  MapDrive = (Err = 0)
  Err.Clear
End Function

'****************************************************************************
'Check each file in the specified folder
'****************************************************************************
Sub DoFiles(folderspec)  
  'Bypass all errors
  On Error Resume Next

  Dim f, fc, f1

  With fso
    'Reference the specified folder
    Set f = .GetFolder(folderspec)
    'Get list of files
    Set fc = f.Files

    'Loop through each file
    'Check for success, and write to log file
    'Increment file count
    For Each f1 In fc
      'With f1
      'Do something here...
      'End With
      Err.Clear
    Next
  End With
  Set f = Nothing
  Set fc = Nothing
End Sub

'****************************************************************************
'Check the specified folder and all items in all sub-folders
'****************************************************************************
Sub DoFolders(folderspec)  
  'Bypass all errors
  On Error Resume Next

  Dim objFolder, objSubFolders, objSubFolder

  DoFiles(folderspec)
  Err.Clear
  Set objFolder = fso.GetFolder(folderspec)  
  Set objSubFolders  = objFolder.SubFolders

  'With objFolder
  'Do something here (same as in DoFiles)...
  'End With

  For Each objSubFolder In objSubFolders
    WriteStatus "Checking " & f1.Path
    DoFolders(f1.path)
    Err.Clear
  Next
  Set objSubFolder = Nothing
  Set objSubFolders = Nothing
  Set objFolder = Nothing
End Sub

'****************************************************************************
'Check all local drives
'****************************************************************************
Sub DoLocalDrives()
  On Error Resume Next
  Dim colDrives, objDrive

  Set colDrives = fso.Drives
  For Each objDrive in colDrives
    If objDrive.DriveType = 2 Then
      'Do something here like...
      'DoFolders(objDrive.DriveLetter & ":\")
    End If
  Next
  Set objDrive = Nothing
  Set colDrives = Nothing
End Sub

'****************************************************************************
' Return a string containing all the drive letters
'****************************************************************************
Function LocalDrives()
  On Error Resume Next
  Dim colDrives, objDrive

  Set colDrives = fso.Drives
  LocalDrives = vbNullString
  For Each objDrive in colDrives
    If objDrive.DriveType = 2 Then
       LocalDrives = LocalDrives & objDrive.DriveLetter
    End If
  Next
  Set objDrive = Nothing
  Set colDrives = Nothing
End Function

'****************************************************************************
'Return the specified date as year-month-day e.g. 2000-04-08
'****************************************************************************
Function FormatThisDate(dtmDate)
  On Error Resume Next

  Dim strDay
  Dim strMonth
  Dim strYear

  strDay = Day(dtmDate)
  strMonth = Month(dtmDate)
  strYear = Year(dtmDate)

  If Len(strDay) = 1 Then
    strDay = "0" & strDay
  End If

  If Len(strMonth) = 1 Then
    strMonth = "0" & strMonth
  End If

  FormatThisDate = strYear & "-" & strMonth & "-" & strDay
End Function

'****************************************************************************
'Write the specified string to the status file
'****************************************************************************
Sub WriteStatus(strStatus)
  On Error Resume Next
  objStatusFile.Write strStatus & "..." & vbNewLine
End Sub

'****************************************************************************
'Standard forced exit procedure
'****************************************************************************
Sub ExitMeNow(strWhyExit)
  On Error Resume Next
  'Write why the exit is occurring
  WriteStatus strWhyExit
  Cleanup
  WScript.Quit
End Sub

'****************************************************************************
'Return only the path portion of the specified file
'****************************************************************************
Function PathFromFile(strFilename)
  On Error Resume Next
  PathFromFile = StrReverse(strFilename)
  PathFromFile = StrReverse(Mid(PathFromFile, InStr(PathFromFile, "\")))
End Function

'****************************************************************************
'Return only the name portion of the specified file
'****************************************************************************
Function NameFromFile(strFilename)
  On Error Resume Next
  NameFromFile = StrReverse(strFilename)
  NameFromFile = StrReverse(Mid(NameFromFile, 1, InStr(1, NameFromFile, "\") - 1))
End Function

'****************************************************************************
'Return a string with of the extension of the specified filename
'****************************************************************************
Function ExtFromFile(strFilename)
  On Error Resume Next
  Dim intPos
  ExtFromFile = StrReverse(strFilename)
  ExtFromFile = StrReverse(Mid(ExtFromFile, 1, InStr(1, ExtFromFile, ".") - 1))
End Function

'****************************************************************************
'Return a string with the extension removed from the specified filename
'****************************************************************************
Function NoExtension(strFilename)
  On Error Resume Next
  Dim intPos
  NoExtension = StrReverse(strFilename)
  NoExtension = StrReverse(Mid(NoExtension, InStr(1, NoExtension, ".") + 1))
End Function

'****************************************************************************
'Return a string converted to "Proper case"
'****************************************************************************
Function MakeProperCase(strString)
  On Error Resume Next
  MakeProperCase = UCase(Left(strString, 1)) & LCase(Mid(strString, 2))
End Function

'****************************************************************************
' Main
'****************************************************************************
On Error Resume Next

Dim strMyName, strMyPath, strStatusFileName, strSource, strFileType, strTempPath, strOldName, strNewName 
Dim fso, objStatusFile, objArgs, objFolderSource, objFilesSource
Dim intCount

'Get the name of this script file
strMyName = NameFromFile(WScript.ScriptFullName)
strMyName = NoExtension(strMyName)
strMyName = MakeProperCase(strMyName) & " script"
'Get the path of this script file
strMyPath = PathFromFile(WScript.ScriptFullName)

If MsgBox("This script will ..." & vbNewLine & vbNewLine & "Do you wish to continue?", vbQuestion + vbYesNo, strMyName) = vbNo Then
  WScript.Quit
End If

'Reference the FileSystemObject
Set fso = CreateObject("Scripting.FileSystemObject")
'Reference the shell obejct
Set shell = CreateObject("WScript.Shell")
'Path of the temp folder
strTempPath = shell.ExpandEnvironmentStrings("%TEMP%") & "\"
'Get the name of this file and append ".txt" to the end of it
'because it will be used to log and status
strStatusFileName = strTempPath & strMyName & "_log.txt"
'Open the text file for writing
Set objStatusFile = fso.OpenTextFile(strStatusFileName, 2, True)

WriteStatus "Initializing " & Now()
'Read arguments into object variable
Set objArgs = WScript.Arguments
If objArgs.Count > 0 Then
  strSource = objArgs(0)
  If objArgs.Count > 1 Then
    strFileType = objArgs(1)
  End If
End If

MsgBox strMyName & " is complete!" & vbNewLine & vbNewLine & "", vbInformation, strMyName
Cleanup
